package com.ekexiu.portal.cms;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.StringReader;
import java.util.Map;

import org.jfw.apt.web.annotation.Path;
import org.jfw.util.ConstData;

import freemarker.cache.TemplateLoader;
import freemarker.template.Configuration;
import freemarker.template.Template;
import freemarker.template.TemplateException;
import freemarker.template.TemplateExceptionHandler;

@Path("/cms")
public class TemplateService {
	
	private File source;
	private Configuration cfg =  new Configuration(Configuration.VERSION_2_3_26);
	public void setSource(File source) {
		this.source = source;
		try {
			this.cfg.setDirectoryForTemplateLoading(source);
		} catch (IOException e) {
			this.source = null;
			this.cfg.setTemplateLoader(new TemplateLoader() {
				@Override
				public Reader getReader(Object templateSource, String encoding) throws IOException {
					StringReader reader = new StringReader("TemplateService'source is invalid dir,so "+templateSource.toString()+" can't read");
					return reader;
				}
				
				@Override
				public long getLastModified(Object templateSource) {
					return 0;
				}
				
				@Override
				public Object findTemplateSource(String name) throws IOException {
					return name;
				}
				
				@Override
				public void closeTemplateSource(Object templateSource) throws IOException {
				}
			});
		}
		cfg.setTemplateExceptionHandler(TemplateExceptionHandler.RETHROW_HANDLER);
	}
	
	
	public void genCnt(String templateName,File dest,Map<String,Object> root) throws IOException, TemplateException{
		if(dest.exists()){
			if(!dest.delete()){
				throw new IOException("delete file["+dest.getAbsolutePath()+"] error");
			}
		}
		Template template = this.cfg.getTemplate(templateName,"UTF-8");
		OutputStream out = new FileOutputStream(dest);
		try {
			template.process(root, new OutputStreamWriter(out, ConstData.UTF8));
			out.flush();
		} finally {
			out.close();
		}
	}
	
	
	

	
	
	
	
	
	

}
