package com.ekexiu.portal.service;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.util.PageQueryResult;

import com.ekexiu.portal.dao.PatentAuthorDao;
import com.ekexiu.portal.dao.PpatentDao;
import com.ekexiu.portal.po.PatentAuthor;
import com.ekexiu.portal.po.Ppatent;
import com.ekexiu.portal.pojo.AssedPatent;

@Path("/ppatent")
public class PpatentServcie {

	@Autowrie
	private PpatentDao ppatentDao;
	@Autowrie
	private PatentAuthorDao patentAuthorDao;
	
	
	
	public PpatentDao getPpatentDao() {
		return ppatentDao;
	}



	public void setPpatentDao(PpatentDao ppatentDao) {
		this.ppatentDao = ppatentDao;
	}



	public PatentAuthorDao getpatentAuthorDao() {
		return patentAuthorDao;
	}



	public void setPatentAuthorDao(PatentAuthorDao paperAuthorDao) {
		this.patentAuthorDao = paperAuthorDao;
	}



	@Get
	@Path("/qo")
	public Ppatent query(@JdbcConn Connection con,String id)throws SQLException{
		return this.ppatentDao.query(con, id);
	}
	@Get
	@Path("/qm")
	public List<Ppatent> query(@JdbcConn Connection con,String[] id)throws SQLException{
		return this.ppatentDao.query(con, id);
	}
	
	@Get
	@Path("/byProfessor")
	public PageQueryResult<AssedPatent> queryByProfessor(@JdbcConn Connection con,String id,@Nullable String name,@DefaultValue("10") int pageSize,@DefaultValue("1") int pageNo)throws SQLException{
		if(name == null ){
			name ="%";
		}else{
			name ="%"+name+"%";
		}
		return this.ppatentDao.pageQueryWithProfessor(con, id, name, pageSize, pageNo);
	}
	@Get
	@Path("/byAuthor")
	public PageQueryResult<AssedPatent> queryByAuthor(@JdbcConn Connection con,String author,String id,@Nullable String name,@DefaultValue("10") int pageSize,@DefaultValue("1") int pageNo)throws SQLException{
		if(name == null ){
			name ="%";
		}else{
			name ="%"+name+"%";
		}
		return this.ppatentDao.pageQueryWithAuthor(con, author,id, name, pageSize, pageNo);
	}
	
	@Get
	@Path("/authors")
	public List<PatentAuthor> queryAuthors(@JdbcConn Connection con,String id)throws SQLException{
		return this.patentAuthorDao.query(con,id);
	}
	@Get
	@Path("/pq")
	public PageQueryResult<Ppatent> pageQuery(@JdbcConn Connection con, @Nullable String qw, @DefaultValue("20") int pageSize, @DefaultValue("1") int pageNo)
			throws SQLException {
		return null == qw ? this.ppatentDao.query(con, pageSize, pageNo) : this.ppatentDao.query(con, "%" + qw + "%", pageSize, pageNo);
	}
	/**
	 * 
	 * @param con
	 * @param uid 专家ID(用户ID) 
	 * @param id  论文ID
	 * @param author 作者名称
	 * @return
	 * @throws SQLException
	 */
	@Post
	@Path("/ass")
	public int ass(@JdbcConn(true) Connection con,String uid,String id,String author)throws SQLException{
		return this.patentAuthorDao.update(con, id, uid, author);
	}
	/**
	 * 
	 * @param con
	 * @param uid 专家ID(用户ID) 
	 * @param id  论文ID
	 * @return
	 * @throws SQLException
	 */
	@Post
	@Path("/cAss")
	public int cAss(@JdbcConn(true) Connection con,String uid,String id)throws SQLException{
		return this.patentAuthorDao.update(con, id, uid);
	}	
	
	@Post
	@Path("/incPageViews")
	public void incPageViews(@JdbcConn(true) Connection con,String id)throws SQLException{
		this.ppatentDao.incPageViews(con, id);
	}
	
	@Post
	@Path("/kw")
	public void update(@JdbcConn(true) Connection con,String id,@Nullable String keywords)throws SQLException{
		this.ppatentDao.update(con, id, keywords);
	}
	@Get
	@Path("/byShareId")
	public Ppatent query(@JdbcConn Connection con,long id)throws SQLException{
		return this.ppatentDao.query(con,id);
	}
}
